/*̧قDoxygenpɏĂ܂B*/
//! \file *********************************************************************
//!
//! \brief STK526pײ
//!
//! - ߲		: AVRpIAR EWAVRGNU GCC
//! -  x޲	: AT90USB162, AT90USB82
//!
//! \author	Atmel Corporation	: http://www.atmel.com \n
//!			xFAQ			: http://support.atmel.no/
//!
//! ***************************************************************************

/* 쌠 (c) 2009, Atmel Corporation S\ς݁B
 *
 * ύX̗L܂͂Ȃſ2ǐ`ł̎gpƍĔzz͈ȉ̏ɍĂ
 * ΋܂B
 *
 * 1.  ނ̍Ĕzz͏̒쌠ʒmȀꗗAƈȉ̂fێ
 *	  Ȃ΂Ȃ܂B
 *
 * 2. 2i`ł̍Ĕzz͂̔zzŒ񋟂ꂽ⑼̑fނŁA̒쌠ʒmA
 *	  ̏ꗗAƈȉ̂fČȂ΂Ȃ܂B
 *
 * 3. ATMEL̖̂͐ɏꂽ̎wȂɂ̿ĳh̑i
 *	  (ۏ)ɎgpłȂ܂B
 *
 * 4. ̿ĳATMELAVRiƂ̊֌WłĕzĎgp邱Ƃł܂B
 *
 * ̿ĳ͂ǂȖI܂͈ÎIȕۏ؁Aܕ̐Ȃ"󂻂̂܂"
 * ATMELɂĒ񋟂AړÎ߂̎sꐫƓK̈ÖٓIȕۏ؂͖
 * mɕ܂BƂATMEL̂悤ȑQ̉\iꂽ
 * ƂĂA{gpłȂA܂͎gpȊOŔ(̑Aƒ
 * fA܂͗v̑Ɋւ鐧Ȃ̑Q܂)AځAԐځAKRA
 * RAʁA܂͕tċN@Ȃ鑹Qɑ΂ĂATMELɐӔC
 * Ȃł傤B
 */

#ifndef STK_526_H
#define STK_526_H

//! @defgroup STK_526_module stk526
//! ̕STK526p̒ʰ޳ۑw܂݂܂B
//! @image html stk_526.gif
//! @{

	//! @defgroup STK_526_usb USBʰ޳ڑ
	//! USBʰ޳ڑ`ϸ
	//! @{
// VBUS_SENSING_IO"ENABLED"ƂĒ`ĂꍇɎgp
#define VBUS_SENSE_PORT		PORTC			// PORTx
#define VBUS_SENSE_PIN		PINC			// PINx
#define VBUS_SENSE_DDR		DDRC			// DDRx
#define VBUS_SENSE_IO		4				// 0`7
	//! @}

	//! @defgroup STK_526_leds LEDǗ
	//! STK526LEDǗ邽߂ϸ
	//! @{
#define LED_PORT			PORTD
#define LED_DDR				DDRD
#define LED_PIN				PIND

#define LED0_BIT			PIND0
#define LED1_BIT			PIND1
#define LED2_BIT			PIND4
#define LED3_BIT			PIND5

#define Leds_init()			(LED_DDR  |=  (1<<LED0_BIT)|(1<<LED1_BIT)|(1<<LED2_BIT)|(1<<LED3_BIT), Leds_off())
#define Leds_on()			(LED_PORT |=  (1<<LED0_BIT)|(1<<LED1_BIT)|(1<<LED2_BIT)|(1<<LED3_BIT))
#define Leds_off()			(LED_PORT &= ~((1<<LED0_BIT)|(1<<LED1_BIT)|(1<<LED2_BIT)|(1<<LED3_BIT)))
#define Leds_set_val(c)		(Leds_off(),LED_PORT |= (c<<4)&((1<<LED0_BIT) | (1<<LED1_BIT) | (1<<LED2_BIT) | (1<<LED3_BIT)))
#define Leds_get_val()		(LED_PORT>>4)

#define Led0_on()			(LED_PORT |=  (1<<LED0_BIT))
#define Led1_on()			(LED_PORT |=  (1<<LED1_BIT))
#define Led2_on()			(LED_PORT |=  (1<<LED2_BIT))
#define Led3_on()			(LED_PORT |=  (1<<LED3_BIT))
#define Led0_off()			(LED_PORT &= ~(1<<LED0_BIT))
#define Led1_off()			(LED_PORT &= ~(1<<LED1_BIT))
#define Led2_off()			(LED_PORT &= ~(1<<LED2_BIT))
#define Led3_off()			(LED_PORT &= ~(1<<LED3_BIT))
#define Led0_toggle()		(LED_PIN  |=  (1<<LED0_BIT))
#define Led1_toggle()		(LED_PIN  |=  (1<<LED1_BIT))
#define Led2_toggle()		(LED_PIN  |=  (1<<LED2_BIT))
#define Led3_toggle()		(LED_PIN  |=  (1<<LED3_BIT))
#define Is_led0_on()		(LED_PIN  &   (1<<LED0_BIT) ? TRUE : FALSE)
#define Is_led1_on()		(LED_PIN  &   (1<<LED1_BIT) ? TRUE : FALSE)
#define Is_led2_on()		(LED_PIN  &   (1<<LED2_BIT) ? TRUE : FALSE)
#define Is_led3_on()		(LED_PIN  &   (1<<LED3_BIT) ? TRUE : FALSE)
	//! @}

	//! @defgroup STK_5226_joy ޮèǗ
	//! STK526̼ޮèǗ邽߂ϸ
	//! @{
#define Joy_init()			(DDRB &= ~((1<<PINB7)|(1<<PINB6)|(1<<PINB5)|(1<<PINB4)|(1<<PINB0)), PORTB |= ((1<<PINB7)|(1<<PINB6)|(1<<PINB5)|(1<<PINB4)|(1<<PINB0)))
#define Push_button_init()	Joy_init()

#define Is_btn_left()		Is_hwb()
#define Is_btn_middle()		((PINB & (1<<PINB0)) ?  FALSE : TRUE)
#define Is_btn_right()		FALSE

#define Is_joy_down()		((PINB & (1<<PINB7)) ?  FALSE : TRUE)
#define Is_joy_right()		((PINB & (1<<PINB6)) ?  FALSE : TRUE)
#define Is_joy_up()			((PINB & (1<<PINB5)) ?  FALSE : TRUE)
#define Is_joy_left()		((PINB & (1<<PINB4)) ?  FALSE : TRUE)

#define Is_btn_not_left()	Is_not_hwb()
#define Is_btn_not_middle()	((PINB & (1<<PINB0)) ?  TRUE : FALSE)
#define Is_btn_not_right()	TRUE

#define Is_joy_not_down()	((PINB & (1<<PINB7)) ?  TRUE : FALSE)
#define Is_joy_not_right()	((PINB & (1<<PINB6)) ?  TRUE : FALSE)
#define Is_joy_not_up()	((PINB & (1<<PINB5)) ?  TRUE : FALSE)
#define Is_joy_not_left()	((PINB & (1<<PINB4)) ?  TRUE : FALSE)

//! (PB04`7)ɑ΂Ċ荞݋
//! - ɑ΂Ċ荞݂\ݒ
//! - ׸މ
//! - 荞݋
#define Switches_enable_it() { \
	PCMSK0 |= (1<<PCINT0)|(1<<PCINT4)|(1<<PCINT5)|(1<<PCINT6)|(1<<PCINT7);\
	PCIFR |= (1<<PCIF0);       \
	PCICR |= (1<<PCIE0);}

//! (PB04`7)ɑ΂Ċ荞݋֎~
//! - 荞݋֎~
//! - ׸މ
//! - Օ
#define Switches_disable_it() { \
	PCICR  &= ~(1<<PCIE0);      \
	PCIFR  |= (1<<PCIF0);       \
	PCMSK0 &= ~((1<<PCINT0)|(1<<PCINT4)|(1<<PCINT5)|(1<<PCINT6)|(1<<PCINT7));}
	//! @}

	//! @defgroup USB_key_HWB HWBtǗ
	//! HWBtPD7ɐڑAWtƂĂgpł܂B
	//! @{
#define Hwb_button_init()	(DDRD &= ~(1<<PIND7))
#define Is_hwb()			((PIND & (1<<PIND7)) ? FALSE : TRUE)
#define Is_not_hwb()		((PIND & (1<<PIND7)) ? TRUE : FALSE)
	//! @}

	//! @defgroup STK526 DataFlash`Ԑݒ
	//! STK526DataFlashɑ΂Ċ邽߂ϸ
	//! @{

// 1AT45DB642D
#define DF_8_MB
#define DF_NB_MEM			1

// PINB0 : SPI]uI݁A݂͂ꂪޮèɂĎgp邽߁A֎~(͌`ԋ֎~)Ȃ΂Ȃ܂B
//		   : ٱߒRɂ݂قǂނƂł邽߁Aޮè͏o͌`Ԃŏ肭Ƃł܂B
// PINB1 : SCKM̕͏o͂łB
// PINB2 : SIM̕͏o͂łB
// PINB3 : SOM͓͂̕łB
// PINC2 : CSM̕͏o͂łB
#define Df_init_spi()		(DDRB  &= ~((1<<PINB3)), \
							 DDRB  |=  ((1<<PINB2)|(1<<PINB1)|(1<<PINB0)), \
							 PORTB |=  ((1<<PINB3)|(1<<PINB2)|(1<<PINB1)|(1<<PINB0)), \
							 DDRC  |=  ((1<<PINC2)), \
							 PORTC |=  ((1<<PINC2)) )
#define Df_select_0()		(PORTC &= ~(1<<PINC2))
#define Df_desel_all()		(PORTC |=  (1<<PINC2))
	//! @}

//! @}

#endif // STK_526
